//
// ERGOT : The Windows MacTierra clone
// copyright (c) 2005 plushpuffin@gmail.com
// http://www.wwddfd.com/
//
// latest build: http://www.wwddfd.com/frell/ergot.zip
//
// licensing terms still under consideration...

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace ERGOT
{
	/// <summary>
	/// Summary description for Library.
	/// </summary>
	public class LibraryForm : System.Windows.Forms.Form
	{
		private string myFileName = "GeneLib.xml";
		internal GeneLib myGeneLib = null;
		internal Machine ma = null;
		private bool _isDisposed = false;

		#region Form Elements

		private System.Windows.Forms.ImageList imgs_FDNormal;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menu_File;
		private System.Windows.Forms.MenuItem mFile_New;
		private System.Windows.Forms.MenuItem mFile_Open;
		private System.Windows.Forms.MenuItem mFile_Save;
		private System.Windows.Forms.MenuItem mFile_SaveAs;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.SaveFileDialog dlg_SaveXML;
		private System.Windows.Forms.TreeView tvGeneLib;
		private System.Windows.Forms.OpenFileDialog dlg_OpenXML;
		#endregion

		public LibraryForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			myGeneLib = new GeneLib();
			myGeneLib.FromXMLFile( myFileName );
			if( ! myGeneLib.isValid )
			{
				myFileName = "";
				//MessageBox.Show(myGeneLib.ErrorString, "WinTierra Gene Library", MessageBoxButtons.OK, MessageBoxIcon.Information);
				this.mFile_New_Click(null,null);
			}
			else
			{
				treeView_Repopulate();
			}
			this.DialogResult = DialogResult.None;
		}

		#region register Machine
		public void register( Machine newMa )
		{
			this.ma = newMa;
			this.myGeneLib.Instructions = ma.instrs;
		}
		#endregion

		#region Properties
		public bool isDisposed
		{
			get { return _isDisposed; }
		}
		#endregion

		#region Dispose
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
			this.DialogResult = DialogResult.Abort;
			_isDisposed = true;
		}
		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(LibraryForm));
			this.tvGeneLib = new System.Windows.Forms.TreeView();
			this.imgs_FDNormal = new System.Windows.Forms.ImageList(this.components);
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menu_File = new System.Windows.Forms.MenuItem();
			this.mFile_New = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.mFile_Open = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.mFile_Save = new System.Windows.Forms.MenuItem();
			this.mFile_SaveAs = new System.Windows.Forms.MenuItem();
			this.dlg_SaveXML = new System.Windows.Forms.SaveFileDialog();
			this.dlg_OpenXML = new System.Windows.Forms.OpenFileDialog();
			this.SuspendLayout();
			// 
			// tvGeneLib
			// 
			this.tvGeneLib.AllowDrop = true;
			this.tvGeneLib.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.tvGeneLib.FullRowSelect = true;
			this.tvGeneLib.ImageList = this.imgs_FDNormal;
			this.tvGeneLib.LabelEdit = true;
			this.tvGeneLib.Location = new System.Drawing.Point(8, 0);
			this.tvGeneLib.Name = "tvGeneLib";
			this.tvGeneLib.Nodes.AddRange(new System.Windows.Forms.TreeNode[] {
																				  new System.Windows.Forms.TreeNode("Gene Library", new System.Windows.Forms.TreeNode[] {
																																											new System.Windows.Forms.TreeNode("thing")})});
			this.tvGeneLib.Size = new System.Drawing.Size(256, 348);
			this.tvGeneLib.TabIndex = 0;
			this.tvGeneLib.DragOver += new System.Windows.Forms.DragEventHandler(this.tvGeneLib_DragOver);
			this.tvGeneLib.AfterLabelEdit += new System.Windows.Forms.NodeLabelEditEventHandler(this.tvGeneLib_AfterLabelEdit);
			this.tvGeneLib.ItemDrag += new System.Windows.Forms.ItemDragEventHandler(this.tvGeneLib_ItemDrag);
			this.tvGeneLib.DragDrop += new System.Windows.Forms.DragEventHandler(this.tvGeneLib_DragDrop);
			// 
			// imgs_FDNormal
			// 
			this.imgs_FDNormal.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit;
			this.imgs_FDNormal.ImageSize = new System.Drawing.Size(32, 32);
			this.imgs_FDNormal.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imgs_FDNormal.ImageStream")));
			this.imgs_FDNormal.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menu_File});
			// 
			// menu_File
			// 
			this.menu_File.Index = 0;
			this.menu_File.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mFile_New,
																					  this.menuItem2,
																					  this.mFile_Open,
																					  this.menuItem1,
																					  this.mFile_Save,
																					  this.mFile_SaveAs});
			this.menu_File.Text = "File";
			// 
			// mFile_New
			// 
			this.mFile_New.Index = 0;
			this.mFile_New.Shortcut = System.Windows.Forms.Shortcut.CtrlN;
			this.mFile_New.Text = "New";
			this.mFile_New.Click += new System.EventHandler(this.mFile_New_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 1;
			this.menuItem2.Text = "-";
			// 
			// mFile_Open
			// 
			this.mFile_Open.Index = 2;
			this.mFile_Open.Shortcut = System.Windows.Forms.Shortcut.CtrlO;
			this.mFile_Open.Text = "Open";
			this.mFile_Open.Click += new System.EventHandler(this.mFile_Open_Click);
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 3;
			this.menuItem1.Text = "-";
			// 
			// mFile_Save
			// 
			this.mFile_Save.Index = 4;
			this.mFile_Save.Shortcut = System.Windows.Forms.Shortcut.CtrlS;
			this.mFile_Save.Text = "Save";
			this.mFile_Save.Click += new System.EventHandler(this.mFile_Save_Click);
			// 
			// mFile_SaveAs
			// 
			this.mFile_SaveAs.Index = 5;
			this.mFile_SaveAs.Shortcut = System.Windows.Forms.Shortcut.CtrlShiftS;
			this.mFile_SaveAs.Text = "Save As";
			this.mFile_SaveAs.Click += new System.EventHandler(this.mFile_SaveAs_Click);
			// 
			// dlg_SaveXML
			// 
			this.dlg_SaveXML.DefaultExt = "xml";
			this.dlg_SaveXML.FileName = "GeneLib";
			this.dlg_SaveXML.Filter = "XML Files (*.xml)|*.xml";
			this.dlg_SaveXML.InitialDirectory = ".";
			this.dlg_SaveXML.Title = "Save Library to XML";
			// 
			// dlg_OpenXML
			// 
			this.dlg_OpenXML.DefaultExt = "xml";
			this.dlg_OpenXML.FileName = "GeneLib";
			this.dlg_OpenXML.Filter = "XML Files (*.xml)|*.xml";
			this.dlg_OpenXML.InitialDirectory = ".";
			this.dlg_OpenXML.Title = "Restore XML to Library";
			// 
			// LibraryForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(272, 373);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.tvGeneLib});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MaximumSize = new System.Drawing.Size(280, 1000);
			this.Menu = this.mainMenu1;
			this.Name = "LibraryForm";
			this.ShowInTaskbar = false;
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Show;
			this.Text = "Library";
			this.ResumeLayout(false);

		}
		#endregion

		#region Drag & Drop Handlers
		private void tvGeneLib_ItemDrag(object sender, System.Windows.Forms.ItemDragEventArgs e)
		{
			this.DoDragDrop(e.Item,DragDropEffects.Move);
		}

		private void tvGeneLib_DragOver(object sender, System.Windows.Forms.DragEventArgs e)
		{
			//See if there is a ListViewItem being dragged
			if( e.Data.GetDataPresent("System.Windows.Forms.ListViewItem", true) )
			{
				System.Windows.Forms.ListViewItem dropItem =
					(System.Windows.Forms.ListViewItem)
					e.Data.GetData(typeof(System.Windows.Forms.ListViewItem));
				if( dropItem.Tag.GetType() == typeof(geneBankRecord) )
				{
					// ListViewItem with geneBankRecord tag found: allow move effect
					e.Effect = DragDropEffects.Move;
				}
				else
				{
					// unknown found: don't allow move effect.
					e.Effect = DragDropEffects.None;
				}
			}
			else
			{
				// No ListViewItem found, prevent move
				e.Effect = DragDropEffects.None;
			}
		}

		private void tvGeneLib_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
		{
		
			//See if there is a ListViewItem being dragged
			if( e.Data.GetDataPresent("System.Windows.Forms.ListViewItem", true) )
			{
				System.Windows.Forms.ListViewItem dropItem =
					(System.Windows.Forms.ListViewItem)
					e.Data.GetData(typeof(System.Windows.Forms.ListViewItem));
				if( dropItem.Tag.GetType() == typeof(geneBankRecord) )
				{
					// ListViewItem with geneBankRecord tag found: allow drop
					geneBankRecord myGBR = (geneBankRecord)(dropItem.Tag);
					geneLibRecord myGLR = new geneLibRecord( myGBR.myGenome, myGBR.mySpeciesName );

					this.myGeneLib[myGLR.myGenome] = myGLR;
					treeView_Repopulate();
					
					saveMyLib();
				}
				else
				{
					// unknown found: don't allow drop.
					;
				}
			}
			else
			{
				// No ListViewItem found, prevent drop.
				;
			}
		}
		#endregion

		#region File Menu Item Event Handlers
		private void mFile_New_Click(object sender, System.EventArgs e)
		{
			myGeneLib = new GeneLib();
			geneLibRecord myGeneLibRecord = new geneLibRecord(Machine.c_default_creature, "" + ((int)Machine.c_default_creature.Length / 2) + "/ancestor");
			myGeneLib[myGeneLibRecord.myGenome] = myGeneLibRecord;
			treeView_Repopulate();
		}

		private void mFile_Open_Click(object sender, System.EventArgs e)
		{
			if(this.dlg_OpenXML.ShowDialog(this) != DialogResult.OK)
			{
				return;
			}
			myFileName = this.dlg_OpenXML.FileName;
			myGeneLib = new GeneLib();
			myGeneLib.FromXMLFile( "genelib.xml" );
			if( myGeneLib.isValid )
			{
				treeView_Repopulate();
			}
			else
			{
				// display error.
				MessageBox.Show(myGeneLib.ErrorString, "WinTierra", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		private void mFile_Save_Click(object sender, System.EventArgs e)
		{
			if( this.myFileName == "" )
			{
				if(this.dlg_SaveXML.ShowDialog(this) != DialogResult.OK)
				{
					return;
				}
				myFileName = this.dlg_SaveXML.FileName;
			}
			saveMyLib();
		}

		private void saveMyLib()
		{
			if( myFileName != null && myFileName != "" )
			{
				this.myGeneLib.ToXMLFile(myFileName);
				if( this.myGeneLib.ErrorCode < 0 )
				{
					// display error.
					MessageBox.Show(myGeneLib.ErrorString, "WinTierra", MessageBoxButtons.OK, MessageBoxIcon.Error);
				}
			}
		}

		private void mFile_SaveAs_Click(object sender, System.EventArgs e)
		{
			if(this.dlg_SaveXML.ShowDialog(this) != DialogResult.OK)
			{
				return;
			}
			saveMyLib();
		}
		#endregion

		private void treeView_Repopulate()
		{
			tvGeneLib.BeginUpdate();
			tvGeneLib.Nodes.Clear();
			tvGeneLib.Nodes.Add( new TreeNode("Library",0,1));
			foreach (geneLibRecord glr in myGeneLib._genelib)
			{
				TreeNode cur = new TreeNode( glr.mySpeciesName, 2, 2 );
				cur.Tag = glr;
				tvGeneLib.Nodes[0].Nodes.Add( cur );

			}
			tvGeneLib.Nodes[0].Expand();
			tvGeneLib.EndUpdate();
		}

		private void tvGeneLib_AfterLabelEdit(object sender, System.Windows.Forms.NodeLabelEditEventArgs e)
		{
			TreeNode cur = e.Node;
			if( cur != null && cur.ImageIndex == 2 )
			{
				if( e.Label == null || e.Label == "" )
				{
					e.CancelEdit = true;
					return;
				}
				// TreeNode of type 'GeneFile' found: allow edit
				geneLibRecord GLR = (geneLibRecord)(cur.Tag);
				// allow label edit
				string part1, part2;
				System.Text.RegularExpressions.Match mEdit = System.Text.RegularExpressions.Regex.Match(e.Label, "\\A\\d+/(.*)\\Z");
					
				part1 = GLR.mySize.ToString();
				if( mEdit.Success )
				{
					part2 = mEdit.Groups[1].Value;
				}
				else
				{
					part2 = e.Label;
				}

				e.CancelEdit = true;

				GLR.mySpeciesName = part1 + '/' + part2;
				cur.Text = GLR.mySpeciesName;

				saveMyLib();
				return;
			}
			else
			{
				// TreeNode of type 'Folder' found: don't allow edit
				e.CancelEdit = true;
				return;
			}
		}


	}
}
