//
// ERGOT : The Windows MacTierra clone
// copyright (c) 2005 plushpuffin@gmail.com
// http://www.wwddfd.com/
//
// latest build: http://www.wwddfd.com/frell/ergot.zip
//
// licensing terms still under consideration...

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace ERGOT
{
	/// <summary>
	/// Summary description for NewSoup.
	/// </summary>
	public class NewSoup : System.Windows.Forms.Form
	{
		public int newSoupSize = 0;
		public bool copyConfig = true;
		System.Globalization.NumberFormatInfo nfi = null;

		private System.Windows.Forms.Button btn_OK;
		private System.Windows.Forms.Button btn_Cancel;
		private System.Windows.Forms.Label lbl_SoupSizeRoot;
		private System.Windows.Forms.NumericUpDown nud_SoupSizeRoot;
		private System.Windows.Forms.Label lbl_numCellsSides;
		private System.Windows.Forms.Label feed_numCellsSides;
		private System.Windows.Forms.Label lbl_numCellsTotal;
		private System.Windows.Forms.Label feed_numCellsTotal;
		private System.Windows.Forms.Label lbl_CopyConfig;
		private System.Windows.Forms.CheckBox chk_CopyConfig;
		private System.Windows.Forms.Label lbl_ReqMemory;
		private System.Windows.Forms.Label feed_ReqMemory;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public NewSoup( int defaultSoupSizeRoot, bool allowCopyConfig )
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			nfi = new System.Globalization.CultureInfo("en-US", false).NumberFormat;
			nfi.NumberGroupSeparator = ",";
			nfi.NumberDecimalDigits = 0;
			nfi.PercentDecimalDigits = 1;

			if( defaultSoupSizeRoot < this.nud_SoupSizeRoot.Minimum || defaultSoupSizeRoot > this.nud_SoupSizeRoot.Maximum )
			{
				this.nud_SoupSizeRoot.Value = 7;
			}
			else
			{
				this.nud_SoupSizeRoot.Value = defaultSoupSizeRoot;
			}
			if( ! allowCopyConfig )
			{
				this.chk_CopyConfig.Checked = false;
				this.lbl_CopyConfig.Visible = false;
				this.chk_CopyConfig.Visible = false;
				int subHeight = this.btn_OK.Top - this.chk_CopyConfig.Top;
				this.Height -= subHeight;
			}
			this.nud_SoupSizeRoot_ValueChanged(null,null);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.lbl_SoupSizeRoot = new System.Windows.Forms.Label();
			this.btn_OK = new System.Windows.Forms.Button();
			this.btn_Cancel = new System.Windows.Forms.Button();
			this.lbl_numCellsSides = new System.Windows.Forms.Label();
			this.nud_SoupSizeRoot = new System.Windows.Forms.NumericUpDown();
			this.feed_numCellsSides = new System.Windows.Forms.Label();
			this.lbl_numCellsTotal = new System.Windows.Forms.Label();
			this.feed_numCellsTotal = new System.Windows.Forms.Label();
			this.chk_CopyConfig = new System.Windows.Forms.CheckBox();
			this.lbl_CopyConfig = new System.Windows.Forms.Label();
			this.lbl_ReqMemory = new System.Windows.Forms.Label();
			this.feed_ReqMemory = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.nud_SoupSizeRoot)).BeginInit();
			this.SuspendLayout();
			// 
			// lbl_SoupSizeRoot
			// 
			this.lbl_SoupSizeRoot.Enabled = false;
			this.lbl_SoupSizeRoot.Location = new System.Drawing.Point(16, 16);
			this.lbl_SoupSizeRoot.Name = "lbl_SoupSizeRoot";
			this.lbl_SoupSizeRoot.Size = new System.Drawing.Size(100, 24);
			this.lbl_SoupSizeRoot.TabIndex = 3;
			this.lbl_SoupSizeRoot.Text = "Size Root";
			this.lbl_SoupSizeRoot.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// btn_OK
			// 
			this.btn_OK.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.btn_OK.Location = new System.Drawing.Point(8, 176);
			this.btn_OK.Name = "btn_OK";
			this.btn_OK.Size = new System.Drawing.Size(112, 32);
			this.btn_OK.TabIndex = 4;
			this.btn_OK.Text = "OK";
			this.btn_OK.Click += new System.EventHandler(this.btn_OK_Click);
			// 
			// btn_Cancel
			// 
			this.btn_Cancel.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.btn_Cancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btn_Cancel.Location = new System.Drawing.Point(128, 176);
			this.btn_Cancel.Name = "btn_Cancel";
			this.btn_Cancel.Size = new System.Drawing.Size(112, 32);
			this.btn_Cancel.TabIndex = 5;
			this.btn_Cancel.Text = "Cancel";
			this.btn_Cancel.Click += new System.EventHandler(this.btn_Cancel_Click);
			// 
			// lbl_numCellsSides
			// 
			this.lbl_numCellsSides.Enabled = false;
			this.lbl_numCellsSides.Location = new System.Drawing.Point(16, 48);
			this.lbl_numCellsSides.Name = "lbl_numCellsSides";
			this.lbl_numCellsSides.Size = new System.Drawing.Size(100, 24);
			this.lbl_numCellsSides.TabIndex = 1;
			this.lbl_numCellsSides.Text = "Height and Width";
			this.lbl_numCellsSides.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// nud_SoupSizeRoot
			// 
			this.nud_SoupSizeRoot.Location = new System.Drawing.Point(136, 16);
			this.nud_SoupSizeRoot.Maximum = new System.Decimal(new int[] {
																			 15,
																			 0,
																			 0,
																			 0});
			this.nud_SoupSizeRoot.Minimum = new System.Decimal(new int[] {
																			 7,
																			 0,
																			 0,
																			 0});
			this.nud_SoupSizeRoot.Name = "nud_SoupSizeRoot";
			this.nud_SoupSizeRoot.Size = new System.Drawing.Size(88, 20);
			this.nud_SoupSizeRoot.TabIndex = 7;
			this.nud_SoupSizeRoot.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.nud_SoupSizeRoot.Value = new System.Decimal(new int[] {
																		   8,
																		   0,
																		   0,
																		   0});
			this.nud_SoupSizeRoot.ValueChanged += new System.EventHandler(this.nud_SoupSizeRoot_ValueChanged);
			// 
			// feed_numCellsSides
			// 
			this.feed_numCellsSides.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.feed_numCellsSides.Enabled = false;
			this.feed_numCellsSides.Location = new System.Drawing.Point(136, 48);
			this.feed_numCellsSides.Name = "feed_numCellsSides";
			this.feed_numCellsSides.Size = new System.Drawing.Size(88, 24);
			this.feed_numCellsSides.TabIndex = 8;
			this.feed_numCellsSides.Text = "0";
			this.feed_numCellsSides.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lbl_numCellsTotal
			// 
			this.lbl_numCellsTotal.Enabled = false;
			this.lbl_numCellsTotal.Location = new System.Drawing.Point(16, 80);
			this.lbl_numCellsTotal.Name = "lbl_numCellsTotal";
			this.lbl_numCellsTotal.Size = new System.Drawing.Size(100, 24);
			this.lbl_numCellsTotal.TabIndex = 9;
			this.lbl_numCellsTotal.Text = "# of Cells";
			this.lbl_numCellsTotal.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// feed_numCellsTotal
			// 
			this.feed_numCellsTotal.BackColor = System.Drawing.SystemColors.Control;
			this.feed_numCellsTotal.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.feed_numCellsTotal.Enabled = false;
			this.feed_numCellsTotal.Location = new System.Drawing.Point(136, 80);
			this.feed_numCellsTotal.Name = "feed_numCellsTotal";
			this.feed_numCellsTotal.Size = new System.Drawing.Size(88, 24);
			this.feed_numCellsTotal.TabIndex = 10;
			this.feed_numCellsTotal.Text = "0";
			this.feed_numCellsTotal.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// chk_CopyConfig
			// 
			this.chk_CopyConfig.CheckAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.chk_CopyConfig.Checked = true;
			this.chk_CopyConfig.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chk_CopyConfig.Location = new System.Drawing.Point(136, 144);
			this.chk_CopyConfig.Name = "chk_CopyConfig";
			this.chk_CopyConfig.Size = new System.Drawing.Size(88, 24);
			this.chk_CopyConfig.TabIndex = 11;
			this.chk_CopyConfig.CheckedChanged += new System.EventHandler(this.chk_CopyConfig_CheckedChanged);
			// 
			// lbl_CopyConfig
			// 
			this.lbl_CopyConfig.Enabled = false;
			this.lbl_CopyConfig.Location = new System.Drawing.Point(16, 144);
			this.lbl_CopyConfig.Name = "lbl_CopyConfig";
			this.lbl_CopyConfig.Size = new System.Drawing.Size(100, 24);
			this.lbl_CopyConfig.TabIndex = 12;
			this.lbl_CopyConfig.Text = "Copy Config?";
			this.lbl_CopyConfig.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lbl_ReqMemory
			// 
			this.lbl_ReqMemory.Enabled = false;
			this.lbl_ReqMemory.Location = new System.Drawing.Point(16, 112);
			this.lbl_ReqMemory.Name = "lbl_ReqMemory";
			this.lbl_ReqMemory.Size = new System.Drawing.Size(100, 24);
			this.lbl_ReqMemory.TabIndex = 13;
			this.lbl_ReqMemory.Text = "Req Memory (MB)";
			this.lbl_ReqMemory.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// feed_ReqMemory
			// 
			this.feed_ReqMemory.BackColor = System.Drawing.SystemColors.Control;
			this.feed_ReqMemory.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.feed_ReqMemory.Enabled = false;
			this.feed_ReqMemory.Location = new System.Drawing.Point(136, 112);
			this.feed_ReqMemory.Name = "feed_ReqMemory";
			this.feed_ReqMemory.Size = new System.Drawing.Size(88, 24);
			this.feed_ReqMemory.TabIndex = 14;
			this.feed_ReqMemory.Text = "0";
			this.feed_ReqMemory.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// NewSoup
			// 
			this.AcceptButton = this.btn_OK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btn_Cancel;
			this.ClientSize = new System.Drawing.Size(248, 212);
			this.ControlBox = false;
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.feed_ReqMemory,
																		  this.lbl_ReqMemory,
																		  this.lbl_CopyConfig,
																		  this.chk_CopyConfig,
																		  this.feed_numCellsTotal,
																		  this.lbl_numCellsTotal,
																		  this.feed_numCellsSides,
																		  this.nud_SoupSizeRoot,
																		  this.btn_Cancel,
																		  this.btn_OK,
																		  this.lbl_SoupSizeRoot,
																		  this.lbl_numCellsSides});
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "NewSoup";
			this.ShowInTaskbar = false;
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Create New Soup";
			this.TopMost = true;
			((System.ComponentModel.ISupportInitialize)(this.nud_SoupSizeRoot)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void btn_OK_Click(object sender, System.EventArgs e)
		{
			this.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.Close();
		}

		private void btn_Cancel_Click(object sender, System.EventArgs e)
		{
			this.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.Close();
		}

		private void nud_SoupSizeRoot_ValueChanged(object sender, System.EventArgs e)
		{
			this.newSoupSize = (int)(this.nud_SoupSizeRoot.Value);
			int numCellsTotal, numCellsSides, reqMemoryMB;
			numCellsTotal = 1 << ((int)newSoupSize << 1);
			numCellsSides = 1 << (int)newSoupSize;
			reqMemoryMB = 1 + ( numCellsTotal ) / ( 256 * 1024 );	// estimate based on experience
			this.feed_numCellsTotal.Text = numCellsTotal.ToString("N", nfi);
			this.feed_numCellsSides.Text = numCellsSides.ToString("N", nfi);
			this.feed_ReqMemory.Text = reqMemoryMB.ToString("N", nfi);
		}

		private void chk_CopyConfig_CheckedChanged(object sender, System.EventArgs e)
		{
			this.copyConfig = chk_CopyConfig.Checked;
		}
	}
}
