using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace ERGOT
{
	/// <summary>
	/// Watson allows the user to step through the execution of a single ergot.
	/// </summary>
	public class Watson : System.Windows.Forms.Form
	{
		private Machine ma;
		private ergot erg;

		#region Form Control Declarations
		private System.Windows.Forms.ListView listView1;
		#endregion
		private System.Windows.Forms.ColumnHeader col_Color;
		private System.Windows.Forms.ColumnHeader col_AbsIndex;
		private System.Windows.Forms.ColumnHeader col_Index;
		private System.Windows.Forms.ColumnHeader col_Hex;
		private System.Windows.Forms.ColumnHeader col_InstrDesc;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Watson()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

		}

		#region register
		public void register( Machine newMa, ergot newErg )
		{
			if( ma != null && erg != null )
			{
//				ma.MachineRefresh += new MachineRefreshHandler(this.Ergot_Refresh_UI);
//				ma.MachineSingleStep += new MachineStepHandler(this.Ergot_Refresh_UI);
//				ma.MachineStop += new MachineRefreshHandler(this.Ergot_Refresh_UI);
			}
			ma = null;
			erg = null;

			if( newMa == null || newErg == null ) { return; }

			ma = newMa;
			erg = newErg;
		}
		#endregion

		#region Machine Event Handlers
		
		private void Ergot_Refresh_UI(object sender, MachineState m)
		{
		}
		#endregion

		#region Dispose
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.listView1 = new System.Windows.Forms.ListView();
			this.col_Color = new System.Windows.Forms.ColumnHeader();
			this.col_AbsIndex = new System.Windows.Forms.ColumnHeader();
			this.col_Index = new System.Windows.Forms.ColumnHeader();
			this.col_Hex = new System.Windows.Forms.ColumnHeader();
			this.col_InstrDesc = new System.Windows.Forms.ColumnHeader();
			this.SuspendLayout();
			// 
			// listView1
			// 
			this.listView1.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left);
			this.listView1.AutoArrange = false;
			this.listView1.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						this.col_Color,
																						this.col_AbsIndex,
																						this.col_Index,
																						this.col_Hex,
																						this.col_InstrDesc});
			this.listView1.FullRowSelect = true;
			this.listView1.GridLines = true;
			this.listView1.LabelWrap = false;
			this.listView1.Name = "listView1";
			this.listView1.Size = new System.Drawing.Size(216, 368);
			this.listView1.TabIndex = 0;
			this.listView1.View = System.Windows.Forms.View.Details;
			// 
			// col_Color
			// 
			this.col_Color.Text = "*";
			this.col_Color.Width = 24;
			// 
			// col_AbsIndex
			// 
			this.col_AbsIndex.Text = "pos";
			this.col_AbsIndex.Width = 64;
			// 
			// col_Index
			// 
			this.col_Index.Text = "#";
			this.col_Index.Width = 32;
			// 
			// col_Hex
			// 
			this.col_Hex.Text = "Hex";
			this.col_Hex.Width = 32;
			// 
			// col_InstrDesc
			// 
			this.col_InstrDesc.Text = "Instr";
			this.col_InstrDesc.Width = 50;
			// 
			// Watson
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(224, 372);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.listView1});
			this.Name = "Watson";
			this.Text = "Watson";
			this.ResumeLayout(false);

		}
		#endregion
	}
}
